%GlobalSearch model optimization using a chi2 difference function       
addpath(genpath('~/matlab/adam_code/prec_model'));
%options = optimset('PlotFcns',@optimplotfval);

%Set constraints of parameters
A=[];
b=[];
Aeq=[];
beq=[];
lb=[0, 0, 0, -2.7397e-04];
ub=[1, 1, 1, 2.7397e-04];


%loop over subjects
for subj=[1:12]
    
    p_rec= prec_noann.prec(subj, :);
    p_rec = p_rec(~isnan(p_rec));
    date = prec_noann.date(subj, :);
    date = date(~isnan(date));
    date=date(1:length(p_rec));
age=[(prec_noann.age(subj)*365)+date];
    %creating vector of ages in days
    net_resvec= prec_noann.SEMVEC(subj, :);
myfunc=@(X) chi2_diff_model(p_rec, date, age, net_resvec, X);
%bestX_symm(subj, 1:4)=fmincon(myfunc, X0, A, b, Aeq, beq, lb, ub);
opts = optimoptions(@fmincon,'Algorithm','interior-point');
problem = createOptimProblem('fmincon','objective',...
myfunc,'x0',X0,'lb',lb,'ub',ub,'options',opts);
gs=GlobalSearch;
bestX(subj, :)= run(gs,problem); %Best-fitting parameter values for each subject
chi2_prec(subj)=chi2_diff_model(p_rec, date, age, net_resvec, bestX(subj, :)); %chi2 difference value for each subject
rmsd_prec(subj)=rmsd_optimized(p_rec, date, age, bestX(subj, :)); %rmsd for each subject
model_dpr_noann(subj, 1:length(date)) = p_rec_model(date, age, bestX(subj, :)); %model-estimated performance for each subject
%bic_dprime(subj) = example_bic_no_likelihood(4,p_rec,model_dprime(subj,:))
end
